Draft PathArray

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page Draft PathArray and the translation is 8% complete.

Outdated translations are marked like this.
Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎română • ‎русский • ‎svenska • ‎Türkçe
Arrow-left.svg Previous: Draft LinkArray.svg Link Array

Draft PathArray.svg Draft PathArray

Menyplacering
Draft → PathArray
Arbetsbänk(ar)
Draft, Arch
Standard genväg
None
Introducerad i version
-
Se även
Draft Array


Beskrivning

The PathArray tool places copies of a selected shape along a selected path, which can be a Draft Wire, a Draft BSpline, and similar edges.

The PathArray tool can be used on 2D shapes created with the Draft Workbench, but can also be used on many types of 3D objects such as those created with the Part, PartDesign, or Arch Workbenches.

To position copies in an orthogonal array use Draft Array; to position copies at specified points use Draft PointArray; to create copies or clones, and manually place them use Draft Move, Draft Rotate, and Draft Clone.

Draft PathArray Example.png

Object arranged along a path


Bruk

  1. Select an object that you wish to distribute.
  2. Select a path object or some edges along which the object will be distributed.
  3. Press the Draft PathArray.svg Draft PathArray button.
  4. The Array object is immediately created. You must change the properties of the array to change the number and direction of copies created.

Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

The base object should be centred around the origin, even if the path starts somewhere else.

Options

There are no options for this tool. Either it works with the selected objects or not.

Properties

  • DATABase: specifies the object to duplicate in the path.
  • DATAPathObj: specifies the path object.
  • DATAPathSubs: specifies the sub-elements (edges) of the path object. This property does not yet appear in the property editor.
  • DATACount: specifies the number of copies of the base object.
  • DATAAlign: if it is True the copies are aligned to the path; otherwise they are left in their default orientation.
Note: in certain cases the shape will appear flat, in reality it may have moved in the 3D space, so instead of using a flat view, change the view to axonometric.
  • DATAXlate: specifies a translation vector (x, y, z) to displace each copy along the path.
Note: when DATAAlign is True, the vector is relative to the local tangent, normal or binormal coordinates; otherwise the vector is relative to the global coordinates.

Skript

The PathArray tool can be used in macros and from the Python console by using the following function:

PathArray = makePathArray(baseobject, pathobject, count, xlate=None, align=False, pathobjsubs=[])
  • Creates a PathArray object from the baseobject, by placing as many as count copies along pathobject.
    • If pathobjsubs is given, it is a list of sub-objects of pathobject, and the copies are created along this shorter path.
  • If xlate is given, it is a FreeCAD.Vector that indicates an additional displacement to move the base point of the copies.
  • If align is True the copies are aligned to the tangent, normal or binormal of the pathobject at the point where the copy is placed.

Example:

import FreeCAD,Draft

p1 = FreeCAD.Vector(500, -1000, 0)
p2 = FreeCAD.Vector(1500, 1000, 0)
p3 = FreeCAD.Vector(3000, 500, 0)
p4 = FreeCAD.Vector(4500, 100, 0)
spline = Draft.makeBSpline([p1, p2, p3, p4])
object = Draft.makePolygon(3, 500)

PathArray = Draft.makePathArray(object, spline, 6)

Technical explanation for the Align property

When DATAAlign is False, the placement of the copied shapes is easy to understand; they are just moved to a different position in their original orientation.

Align false

Object arranged along a closed path in the original orientation


When DATAAlign is True, the positioning of the shapes becomes a bit more complex:

  1. First, Frenet coordinate systems are built on the path: X is tangent, Z is normal, Y is binormal.
  2. Then the original object is copied to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.
Patharray alignment annotated.png

Object arranged along a closed path; description of components and path


The following images show how the array is produced, depending on which plane the path is.

Path on XY Plane:

Patharray alignment.png

Object arranged along a closed path which is aligned to the XY plane


Path on XZ Plane:

Patharray alignment-XZ.png

Object arranged along a closed path which is aligned to the XZ plane


Path on YZ Plane:

Patharray alignment-YZ.png

Object arranged along a closed path which is aligned to the YZ plane


As you reorient the path but not the object, the result is consistent: the object remains aligned to the path the way it was before reorienting the path.

Editor: thank you to user DeepSOIC for this explanation.

Arrow-left.svg Previous: Draft LinkArray.svg Link Array